
from Image import Image
from ODEObject import ODEObject

import ode
import math 

def coord(x,y):
    "Convert world coordinates to pixel coordinates."
    return 400+170*x, 170*y

def rot(body):
    return math.degrees(math.acos(body.getRotation()[0]))


class  Box(ODEObject):

    def __init__(self,world,space,list, pos=(0,0), size = (.1,.2,.1), color=(1,1,1,1)):
        # Define the mass setup
        mass = ode.Mass()
        mass.setBox(800, size[0], size[1], size[2])

        ODEObject.__init__(self,world,space,list,ode.GeomBox(space, size), mass,pos=pos, image='blank', color = color)
        
        # Define the Geometry
        self.shape = 'box'
        self.boxsize = size
        
        self.height = size[1] * 170
        self.width = size[0] * 170
