
from Image import Image
from ODEObject import ODEObject

import ode
import math 

radius = 0.1

def coord(x,y):
    "Convert world coordinates to pixel coordinates."
    return 400+170*x, 170*y

def rot(body):
    return math.degrees(math.acos(body.getRotation()[0]))


class  Fan(ODEObject):

    def __init__(self,world,space,list, pos=(0,0), force=(10,0,0)):
        """"""
        # Define the mass setup
        mass = ode.Mass()
        mass.setSphere(100, 0.05)

        ODEObject.__init__(self,world,space,list, ode.GeomSphere(space, radius), mass, pos=pos)

        self.force = force
        self.width= 17*2
        self.height = 17*2
        
        # Define the Geometry
        self.shape = 'fan'
        self.radius = radius
        self.geom = ode.GeomSphere(space, self.radius)
        
      

        loc = (pos[0],pos[1],0)
        self.j1 = ode.BallJoint(world)
        self.j1.attach(self.body, ode.environment)
        self.j1.setAnchor(loc)

        
    def update(self, list):
        x1,y1,z1 = self.body.getPosition()

        for thing in list:
            x2,y2,z2 = thing.body.getPosition()
            if abs(y2 - y1) <= 0.5:
                thing.body.addForce(self.force)
