
from Image import Image
from ODEObject import ODEObject
from Balloon import Balloon
from Fan import Fan
from Box import Box

import ode
import math 

def coord(x,y):
    "Convert world coordinates to pixel coordinates."
    return 400+170*x, 170*y

def rot_m(theta):
    return (math.cos(theta), math.sin(theta), 0, -math.sin(theta), math.cos(theta),0,0,0,1)
    

class  JayBalloon(ODEObject):

    def __init__(self,world,space,list, pos=(-1,1)):
        self.component_list = []
        self.joints = []

        x1, y1 = pos
        
        r = .55 # balloon radius
        q = .1 # delta between basket and ball
        w = .2 # box width
        h = .2 # box height
        links = 1 # number or rope links
        len = math.sqrt((q+r)**2 + (r-w/2.0)**2) #lenght of rope
        theta = math.asin((q+r)/len)
        
        print theta, math.acos((r-w/2.0)/len)

        
        self.balloon = Balloon(world,space,list,pos=(0,1), radius = r)
        self.box = Box(world,space,list, pos=(0,0), size = (w, h, 1))
        
        #build the rope
        #rope1 = Box(world,space,list, pos=(0,0), size = (.01, len, .01))
        #rope2 = Box(world,space,list, pos=(0,0), size = (.01, len, .01))
        

        #set positions
        self.balloon.body.setPosition((x1,y1,0))
        self.box.body.setPosition((x1,y1-r-h/2-q,0))
        
        #rope1.body.setPosition((x1+r, y1- (q+r)/2.0, 0))
        #rope2.body.setPosition((x1-2*r, y1- (q+r)/2, 0))
        
        #rope1.body.setRotation(rot_m(theta/2))
        #rope2.body.setRotation(rot_m(-theta))
        
        
        #stick the rope to the ball
        
        #j1 = ode.FixedJoint(world)
        #j1.attach(balloon.body,rope1.body)
        #j1.setFixed()
        #self.joints.append(j1)

        """
        j1 = ode.FixedJoint(world)
        j1.attach(balloon.body,rope2.body)
        j1.setFixed()
        self.joints.append(j1)
        

        """
        #make the joints
        j1 = ode.FixedJoint(world)
        j1.attach(self.balloon.body,self.box.body)
        j1.setFixed()
        #j1.setAnchor((0,.5,0))
        
        
        self.joints.append(j1)
        
        
        #self.component_list.append(balloon)
        

    def draw(self):
        for i in self.component_list:
            i.draw()

    def update(self):
        self.balloon.body.addForce((0,380,0))
